#!/usr/bin/python3

# ## {R2D2919B742E} ##
# ###########################################################################
# What if magic existed?
# What if a place existed where your every thought and dream come to life.
# There is only one catch: it has to be written down.
# Such a place exists, it is called programming.
#    - Scott Taylor Reph, RightThumb.com
# ###########################################################################
# ## {C3P0D40fAe8B} ##

##################################################
import os, sys, time
##################################################
import _rightThumb._construct as __
appDBA = __.clearFocus( __name__, __file__ )
__.appReg = appDBA

def focus( parentApp='', childApp='', reg=True ):
    global appDBA
    f = __.appName( appDBA, parentApp, childApp )
    if reg:
        __.appReg = f
    return f
__.registeredApps.append( focus() )
import _rightThumb._base3 as _
_.load()
##################################################
import _rightThumb._vars as _v
import _rightThumb._string as _str
##################################################

def appSwitches():
    _.switches.register( 'UUID', '-uuid' )
_.autoBackupData = __.setting('receipt-log')
__.releaseAcquiredData = __.setting('receipt-file')
__.myFileLocations_SKIP_VALIDATION = False
__.isRequired_Pipe = False
__.isRequired_Pipe_or_File = False
__.pre_error = False
__.switch_raw = []
# __.switch_raw = [ 'Delim' ]
# __.isRequired_or_List = ['Pipe','Files','Plus']
# __.setting( 'app-switches-raw', [ 'Delim' ] )

_.appInfo[focus()] = {
    'file': 'cron.py',
    'liveAppName': __.thisApp( __file__ ),
     'description': 'webserver cron manager',
    'categories': [
                        'cron',
                        'web',
                        'webserver',
                ],
    'usage': [
                        # 'epy another',
                        # 'e nmap',
                        # '',
    ],
    'relatedapps': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'prerequisite': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'examples': [
                        _.hp('p vps-hoth-7i0ZA-7GvQNS-email-send -file file.txt'),
                        '',
    ],
    'columns': [
                       # { 'name': 'name', 'abbreviation': 'n' },
                       # { 'name': '{1}', 'abbreviation': '{0}', 'sort': '{2}' },
    ],
    'aliases': [
                       # 'this',
                       # 'app',
    ],
    'notes': [
                       # {},
    ],
}
_.appData[focus()] = {
        'start': __.startTime,
        'uuid': '',
        'audit': [],
        'pipe': False,
        'data': {
                    'field': {'sent': [], 'received': [] }, # { 'label': '', 'context': [],  }
                    'table': {'sent': [], 'received': [] }, 
        },
    }

def registerSwitches( argvProcessForce=False ):
    global appDBA
    if not __.appReg == appDBA and appDBA in __.appReg:
        if not __name__ == '__main__':
            _.argvProcess = argvProcessForce
        else:
            _.argvProcess = True
        _.load()

        _.appInfo[__.appReg] = _.appInfo[appDBA]
        _.appData[__.appReg] = _.appData[appDBA]
    __.constructRegistration( _.appInfo[__.appReg]['file'],__.appReg )
    appSwitches()
    _.myFileLocation_Print = False
    _.switches.trigger( 'Files', _.myFileLocations, vs=True )
    _.switches.trigger( 'Folder', _.myFolderLocations )
    _.switches.trigger( 'URL', _.urlTrigger )
    _.switches.trigger( 'Ago', _.timeAgo )
    _.switches.trigger( 'Duration', _.timeFuture )
    _.defaultScriptTriggers()
    _.switches.process()
if not __name__ == '__main__':
    _.argvProcess = False
else:
    _.argvProcess = True
registerSwitches()

def fieldSet( switchName, switchField, switchValue, theFocus=False ):
    if not type( theFocus ) == bool:
        theFocus = theFocus
    _.switches.fieldSet( switchName, switchField, switchValue, theFocus )
if __name__ == '__main__':
    if not sys.stdin.isatty():
        _.setPipeData( sys.stdin.readlines(), __.appReg, clean=True )
_.postLoad( __file__ )

########################################################################################
# START
import simplejson
import urllib3

def action():
    uuid = _.switches.values('UUID')[0]
    USER_NAME = "admin_user-meta-web"
    PASSWORD = _keychain.imp.key('sql')
    # _.pr(PASSWORD)
    import pymysql.cursors
    SERVER_URL = "localhost"
    DB = "admin_db-meta-web"
    SQL_CONNECTION = pymysql.connect(host=SERVER_URL,
    user=USER_NAME,
    passwd=PASSWORD,
    db=DB,
    charset='utf8mb4',
    cursorclass=pymysql.cursors.DictCursor,
    autocommit=True)
    _.pr( '__________________________________________________________________________________' )
    _.pr( '### sending -', _.isDate(time.time())['fdate'] )
    cursor = SQL_CONNECTION.cursor()
    sql = 'SELECT uuid, company, name, email, tbl, subject, message FROM app_B518DA1C_schedule WHERE uuid="'+uuid+'" ORDER BY id DESC;'
    sql_exec = cursor.execute(sql)
    raw = cursor.fetchall()
    if not raw:
        _.pr( 'Email not sent, record deleted' )
        return None
    rec = raw[0]
    SQL_CONNECTION.close()
    _.pv(rec)
    urllib3.disable_warnings()
    http = urllib3.PoolManager()
    response = http.request("POST", "https://eyeformeta.com/apps/email/send-email.php", fields={
            "uuid": rec['uuid'],
            "to_name": rec['name'],
            "to_email": rec['email'],
            "subject": rec['subject'],
            "body": rec['message'],
            "template": "blank.htm",
        })
    if 'Email message sent.' in response.data.decode("utf-8"):
        _.pr('Email sent')
    else:
        _.pr('Error: Email NOT sent')
_keychain = _.regImp( __.appReg, 'keychain' )

########################################################################################
if __name__ == '__main__':
    action()
    __.isExit()
